Loading...
Searching...
No Matches
Restart Marker Plugin
Globus FTP Client API » Plugins

Restart Marker Plugin. More...

## Macros

#define | GLOBUS_FTP_CLIENT_RESTART_MARKER_PLUGIN_MODULE (&globus_i_ftp_client_restart_marker_plugin_module)

## Typedefs

typedef globus_bool_t(* | globus_ftp_client_restart_marker_plugin_begin_cb_t) (void *user_arg, globus_ftp_client_handle_t *handle, const char *source_url, const char *dest_url, globus_ftp_client_restart_marker_t *user_saved_marker)
| Transfer begin callback.
typedef void(* | globus_ftp_client_restart_marker_plugin_marker_cb_t) (void *user_arg, globus_ftp_client_handle_t *handle, globus_ftp_client_restart_marker_t *marker)
typedef void(* | globus_ftp_client_restart_marker_plugin_complete_cb_t) (void *user_arg, globus_ftp_client_handle_t *handle, globus_object_t *error, const char *error_url)

## Functions

globus_result_t | globus_ftp_client_restart_marker_plugin_init (globus_ftp_client_plugin_t *plugin, globus_ftp_client_restart_marker_plugin_begin_cb_t begin_cb, globus_ftp_client_restart_marker_plugin_marker_cb_t marker_cb, globus_ftp_client_restart_marker_plugin_complete_cb_t complete_cb, void *user_arg)
globus_result_t | globus_ftp_client_restart_marker_plugin_destroy (globus_ftp_client_plugin_t *plugin)

## Detailed Description

Restart Marker Plugin.

This plugin is intended to allow users to make restart markers persistent. During a transfer, every marker received will result in the user's 'marker' callback being called with the new restart marker that can be stored. If the application were to prematurely terminate (while transferring), the user (after restarting the application) could pass this stored marker back to the plugin via the 'begin' callback to force the transfer to be restarted from the last marked point.

## Macro Definition Documentation

## GLOBUS_FTP_CLIENT_RESTART_MARKER_PLUGIN_MODULE

#define GLOBUS_FTP_CLIENT_RESTART_MARKER_PLUGIN_MODULE (&globus_i_ftp_client_restart_marker_plugin_module)

Module descriptor

## Typedef Documentation

## globus_ftp_client_restart_marker_plugin_begin_cb_t

typedef globus_bool_t(* globus_ftp_client_restart_marker_plugin_begin_cb_t) (void *user_arg, globus_ftp_client_handle_t *handle, const char *source_url, const char *dest_url, globus_ftp_client_restart_marker_t *user_saved_marker)

Transfer begin callback.

This callback is called when a get, put, or third party transfer is started.

The intended use for this callback is for the user to use the transfer urls to locate a restart marker in some persistent storage. If one is found, it should be copied into 'user_saved_marker' and the callback should return GLOBUS_TRUE. This will cause the transfer to be restarted using that restart marker. If one is not found, return GLOBUS_FALSE to indicate that the transfer should proceed from the beginning.

In any case, this is also an opportunity for the user to set up any storage in anticipation of restart markers for this transfer.

Parameters

  handle | this the client handle that this transfer will be occurring on
  user_arg | this is the user_arg passed to the init func
  source_url | source of the transfer (GLOBUS_NULL if 'put')
  dest_url | dest of the transfer (GLOBUS_NULL if 'get')
  user_saved_marker | pointer to an initialized restart marker

Returns
  - GLOBUS_TRUE to indicate that the plugin should use 'user_saved_marker' to restart the transfer (and subsequently, destroy the marker)
  - GLOBUS_FALSE to indicate that 'user_saved_marker' has not been modified, and that the transfer should proceed normally

## globus_ftp_client_restart_marker_plugin_complete_cb_t

typedef void(* globus_ftp_client_restart_marker_plugin_complete_cb_t) (void *user_arg, globus_ftp_client_handle_t *handle, globus_object_t *error, const char *error_url)

Transfer complete callback

This callback will be called upon transfer completion (successful or otherwise)

Parameters

  handle | this the client handle that this transfer was occurring on
  user_arg | this is the user_arg passed to the init func
  error | the error object indicating what went wrong (GLOBUS_NULL on success)
  error_url | the url which is the source of the above error (GLOBUS_NULL on success)

Returns
  - n/a

## globus_ftp_client_restart_marker_plugin_marker_cb_t

typedef void(* globus_ftp_client_restart_marker_plugin_marker_cb_t) (void *user_arg, globus_ftp_client_handle_t *handle, globus_ftp_client_restart_marker_t *marker)

Restart marker received callback

This callback will be called every time a restart marker is available.

To receive restart markers in a 'put' or 'third_party_transfer', the transfer must be in Extended Block mode. 'get' transfers will have their markers generated internally. Markers generated internally will be 'sent' at most, once per second.

The intended use for this callback is to allow the user to store this marker (most likely in place of any previous marker) in a format that the 'begin_cb' can parse and pass back.

Parameters

  handle | this the client handle that this transfer is occurring on
  user_arg | this is the user_arg passed to the init func
  marker | the restart marker that has been received. This marker is owned by the caller. The user must use the copy method to keep it. Note: this restart marker currently contains all ranges received as of yet. Should I instead only pass a marker with the ranges just made available? If so, the user may need a way to combine restart markers (globus_ftp_client_restart_marker_combine)

Returns
  - n/a

## Function Documentation

## globus_ftp_client_restart_marker_plugin_destroy()

globus_result_t globus_ftp_client_restart_marker_plugin_destroy | ( | globus_ftp_client_plugin_t * | plugin | ) |

Destroy restart marker plugin

Frees up memory associated with plugin

Parameters

  plugin | plugin previously initialized with init (above)

Returns
  - GLOBUS_SUCCESS
  - Error on NULL plugin

## globus_ftp_client_restart_marker_plugin_init()

globus_result_t globus_ftp_client_restart_marker_plugin_init | ( | globus_ftp_client_plugin_t * | plugin,
|  | globus_ftp_client_restart_marker_plugin_begin_cb_t | begin_cb,
|  | globus_ftp_client_restart_marker_plugin_marker_cb_t | marker_cb,
|  | globus_ftp_client_restart_marker_plugin_complete_cb_t | complete_cb,
|  | void * | user_arg
| ) |  |

Initialize a restart marker plugin

This function initializes a restart marker plugin. Any params except for the plugin may be GLOBUS_NULL

Parameters

  plugin | a pointer to a plugin type to be initialized
  user_arg | a pointer to some user specific data that will be provided to all callbacks
  begin_cb | the callback to be called upon the start of a transfer
  marker_cb | the callback to be called with every restart marker received
  complete_cb | the callback to be called to indicate transfer completion

Returns
  - GLOBUS_SUCCESS
  - Error on NULL plugin
  - Error on init internal plugin